;BomberMan 0.21 on 1998-2000 By Eric Piel  < Eric.Piel@etu.utc.fr >
;graphics by Alapanamo < doggone@webcombo.net >
;need some undocumented Z80 instructions


;INFO
;20 frames/sec
;150 sec
;15*9 board


#include CRASH82.INC
;More ROMCALLs
;HTIMESL : very slow, it uses add and djnz
HTIMESL		= $1EFE 	;HLDE	HL=H*L, DE=L

SZTitle:
.db "BomberMan",6,"MultiPlayer",0	;6 is a big space

;;;;;;;;;  CONSTANTs  ;;;;;;;;;;;
vERSION		= 20h			; 2= B =BMMP 0= version #0 ; used only for the link
fRAMEpERsEC	= 20			; just for the timer
sCREENhEIGHT	= 9*6
sCREENwIDTH	= 15*6
sCREENoRIX	= 3
sCREENoRIY	= 1
bOMBfLASH	= 28
SizeBBM		= 11			; the size of information in the calc memory
SizeBBMLvl	= 7			; the size of information in the level data

;;;;;;;;;  LOCATIONs  ;;;;;;;;;;;
;		66 bytes for all OPX
PlayerWorking	= OP1		;byte	;each set bit coresponds to the BBM on which work is being done
Linked		= OP1 + 1	;byte	;to know if we've got to send infos: 0=> not linked
PlayersState	= OP1 + 2	;byte	;Each set bit signifies BBM# is dead
GameTimer	= OP1 + 3	;word
StringTemp	= OP6 + 10	;6 bytes (less most of the time) finishing at this address
BBM1		= OP1 + 5
BBM2		= BBM1 + SizeBBM
BBM3		= BBM1 + (2*SizeBBM)
BBM4		= BBM1 + (3*SizeBBM)
;Relative position of the BBM information
BBMPos		= 0			;Position
BBMY		= 0
BBMX		= 1
BBMDir		= 2			;direction			;if necessary it can be put in one byte
BBMOldDir	= 3			;direction of BBM drawn		;each one is 4 bits
BBMRem		= 4			;Nb Of Bombs Remaining
BBMExp		= 5			;Expantion
BBMBn		= 6			;Bonnus 4MSD: bad thing #  2LSB: speed
BBMType		= 7			;How is managed the BBM
BBMAIState	= 8			;1 byte to save info for the AI routine
BBMSprPtr	= 9			;Pointer to its sprite (2 bytes)

;;;;;;;;;;;  BBM Types  ;;;;;;;;;
TypeNH		= 0			;Not Here
TypeOC1		= 1			;On calc1
TypeOC2		= 2			;On calc2
TypeAI1		= 3			;AI 1 neuron
TypeAI2		= 4			;AI 2 neurons
TypeLK		= 5			;Link


;;;;;;;  Bomb Allocation Table  ;;;;;;;;
BATStart	= TEXT_MEM
SizeBAT		= 128
;relative position of the bomb information
BbTimer		= 0
BbPos		= 1
BbY		= 1
BbX		= 2		;;could be only one byte
BbBBMNb		= 3		;2LSB :BBM# and the other stuff is the explosion size
SizeBb		= 4

LvlBuf		= APD_BUF	;just for 135	;TEXT_MEM2

Start:
	ld	hl,OP1
	ld	de,OP1 + 1
	ld	(hl),0
	ld	bc,66 - 1
	ldir				;clear memory for stringtemp and BBMType
	ld	a,TypeOC1
	ld	(BBM1 + BBMType),a
	ld	a,TypeOC2
	ld	(BBM2 + BBMType),a
Reboot:
	ld	a,40h			;reset the screen as it is normaly in case we've stoped in an explosion
	out	(P_LCD_CON),a
	res	1,(iy + 0dh)		;do not affect text memory
	res	7,(iy + 14h)		;write directly to LCD

	ld	hl,BitmapTitle
	ld	de,GRAPH_MEM
	ld	bc,12*25
	ldir
	ld	h,d
	ld	l,e
	inc	de
	ld	(hl),0
	ld	bc,2ffh - (12*25)
	ldir
	call	CR_GRBCopy

CheckAPD_BUF:			; By Hideaki Omuro & Jeff Mears
	LD  A, (INT_STATE)	; Find the Interrupt State
	OR  A \ JR  Z, OkAPD    ; If clear, then go ahead and use the APD_BUF
	LD	HL, (APD_FREE)	; Find the amount of free APD_BUF
	LD	DE, 9*15	; Compare to amount of memory needed
	CALL	CP_HL_DE
	JR	NC, OkAPD	; Go ahead and use the APD_BUF if enough.
	ld	hl,$1A10
	ld	(GRAF_CURS), hl
	ld	hl,UnloadStr
	ROM_CALL(D_ZM_STR)
	jp	CR_KHAND        ; Wait for a key and Quit
OkAPD:


MainMenu:
	ld	d,1
	call	CR_GRBCopy		;delete menu
MMReDisplay:
	ld	hl,SZMMNew		;SZMMCont
	ld	b,MMNbEntry
	ld	c,d
	ld	a,24h			;1eh when 3 entries
MMLoop:
	ld	(CURSOR_Y),a
	ld	a,18h			;10h
	ld	(CURSOR_X),a
	ld	a,6			;big space (4px)
	dec	c
	jr	nz,MMNoCur
	ld	a,(CURSOR_X)
	inc	a
	ld	(CURSOR_X),a	
	ld	a,0c1h			;'[' (3px)
MMNoCur:
	push	de
	ROM_CALL(M_CHARPUT)		;destroys DE
	ROM_CALL(D_ZM_STR)
	ld	a,6			;big space
	inc	c
	dec	c
	jr	nz,MMNoCur2
	ld	a,']'
MMNoCur2:
	ROM_CALL(M_CHARPUT)	
	pop	de
	ld	a,(CURSOR_Y)
	add	a,9
	djnz	MMLoop
MMKeyLoop:
	halt
	call	GET_KEY
	cp	G_DOWN
	jr	z,MMKBUp		;MMKBDown
	cp	G_UP
	jr	z,MMKBUp
	cp	G_ENTER
	jr	z,MMSelect
;	cp	G_2ND
;	jr	z,MMSelect
	cp	G_MODE
	ret	z
	jr	MMKeyLoop
MMSelect:
	ld	a,d
;	dec	a
;	jp	z,ContinueGame
	dec	a
	jp	z,PlayerMenu
	jr	OptionMenu
MMKBDown:
;	inc	d
;	ld	a,MMNbEntry
;	cp	d
;	jr	nc,MMReDisplay
;	ld	d,1			;;jr	MainMenu
;	jr	MMReDisplay
MMKBUp:
	dec	d
	jr	nz,MMReDisplay
	ld	d,MMNbEntry
	jr	MMReDisplay

OptionMenu:
	ld	d,1
	call	CR_GRBCopy		;delete menu
OMReDisplay:
	ld	hl,SZOMNbattle
	ld	b,OMNbEntry
	ld	c,d
	ld	a,24h
OMLoop:
	ld	(CURSOR_Y),a
	ld	a,10h
	ld	(CURSOR_X),a
	ld	a,6			;big space (4px)
	dec	c
	jr	nz,OMNoCur
	ld	a,0cfh			;'<' (4px)
OMNoCur:
	push	de
	ROM_CALL(M_CHARPUT)		;destroys DE
	ROM_CALL(D_ZM_STR)
	push	hl
	ld	a,b
	cp	2
	jr	z,OMDispBattle
	ld	hl,GameDuration
	jr	OMDispHL
OMDispBattle:
	ld	hl,NbOfGameToWin
OMDispHL:
	ld	l,(hl)
	ld	h,0
	call	M_HL_DECI		;destroys DE
	pop	hl
	ld	a,6			;big space
	inc	c
	dec	c
	jr	nz,OMNoCur2
	ld	a,5h			;'>'
OMNoCur2:
	ROM_CALL(M_CHARPUT)
	ld	a,6			;big space
	ROM_CALL(M_CHARPUT)
	pop	de
	ld	a,(CURSOR_Y)
	add	a,9
 	djnz	OMLoop
OMKeyLoop:
	halt
	call	GET_KEY
	cp	G_DOWN
	jr	z,OMKBDown
	cp	G_UP
	jr	z,OMKBUp
	cp	G_LEFT
	jr	z,OMDec
	cp	G_RIGHT
	jr	z,OMInc
	cp	G_MODE
	jp	z,MainMenu
	jr	OMKeyLoop
OMDec:
	ld	a,d
	cp	1
	jr	z,OMDBattle
	ld	hl,GameDuration			;15<255	+5
	ld	a,(hl)
	cp	16
	jr	c,OMKeyLoop
	sub	5
	ld	(hl),a
	jr	OMReDisplay
OMDBattle:
	ld	hl,NbOfGameToWin		;1<8	+1
	ld	a,(hl)
	cp	2
	jr	c,OMKeyLoop
	dec	(hl)
	jp	OMReDisplay
OMInc:
	ld	a,d
	cp	1
	jr	z,OMIBattle
	ld	hl,GameDuration			;15<255	+5
	ld	a,(hl)
	cp	255
	jr	z,OMKeyLoop
	add	a,5
	ld	(hl),a
	jp	OMReDisplay
OMIBattle:
	ld	hl,NbOfGameToWin		;1<8	+1
	ld	a,7
	cp	(hl)
	jr	c,OMKeyLoop
	inc	(hl)
	jp	OMReDisplay
OMKBDown:
;	inc	d				;both do the same thing
;	ld	a,OMNbEntry
;	cp	d
;	jp	nc,OMReDisplay
;	ld	d,1
;	jp	OMReDisplay
OMKBUp:
;	dec	d
;	jp	nz,OMReDisplay
;	ld	d,OMNbEntry
	ld	a,00000011b			;1 or 2
	xor	d
	ld	d,a
	jp	OMReDisplay

PlayerMenu:
	ld	d,1
	call	CR_GRBCopy		;delete menu
PMReDisplay:
	ld	b,PMNbEntry
	ld	c,d
	ld	a,1ch
PMLoop:
	ld	(CURSOR_Y),a
	ld	a,12h
	ld	(CURSOR_X),a
	ld	hl,SZPMPlayer
	push	de
	ROM_CALL(D_ZM_STR)
	ld	a,b
	neg
	add	a,PMNbEntry + 1 + '0'	;PMNbEntry + 1 => (b 4->1) a 1->4		'0'=> a char
	ROM_CALL(M_CHARPUT)
	ld	a,6			;big space (4px)
	ROM_CALL(M_CHARPUT)
	ld	a,6			;big space
	dec	c
	jr	nz,PMNoCur
	ld	a,0cfh			;'<' (4px)
PMNoCur:
	ROM_CALL(M_CHARPUT)		;destroys DE
	ld	a,b			;;push af/pop hl
	neg
	add	a,PMNbEntry + 1
	ld	d,a
	call	PMFindTypeNum
	ld	e,(hl)			;we've got the type # in e
	inc	e
	ld	hl,SZPMPlayer
	xor	a
PMFindType:
	push	bc			;b>=1
	cpir
	pop	bc
	dec	e
	jr	nz,PMFindType		;we've got the type zstring in hl
 	ROM_CALL(D_ZM_STR)
	ld	a,6			;big space
	inc	c
	dec	c
	jr	nz,PMNoCur2
	ld	a,5h			;'>'
PMNoCur2:
	ROM_CALL(M_CHARPUT)
	ld	a,6			;big space
	ROM_CALL(M_CHARPUT)
	ld	a,6			;big space
	ROM_CALL(M_CHARPUT)
	pop	de
	ld	a,(CURSOR_Y)
	add	a,9
 	djnz	PMLoop
PMKeyLoop:
	halt
	call	GET_KEY
	cp	G_DOWN
	jr	z,PMKBDown
	cp	G_UP
	jr	z,PMKBUp
	cp	G_LEFT
	jr	z,PMDec
	cp	G_RIGHT
	jr	z,PMInc
	cp	G_ENTER
	jr	z,PMSelect
;	cp	G_2ND
;	jr	z,PMSelect
	cp	G_MODE
	jp	z,MainMenu
	jr	PMKeyLoop
PMSelect:					;; check it's OK hardly?
	ld	bc,SizeBBM
	ld	hl,BBM1 + BBMType
	ld	a,(hl)
	add	hl,bc
	or	(hl)
	add	hl,bc
	or	(hl)
	add	hl,bc
	or	(hl)
	jr	nz,LevelMenu
	jr	PMKeyLoop

PMDec:
	call	PMFindTypeNum
	dec	(hl)
	jp	p,PMReDisplay			;0<5	+1
	inc	(hl)
	jr	PMKeyLoop
PMInc:
	call	PMFindTypeNum
	ld	a,(hl)
	cp	5				;0<5	+1
	jr	nc,PMKeyLoop
	inc	(hl)
	jp	PMReDisplay
PMKBDown:
	inc	d
	ld	a,PMNbEntry
	cp	d
	jp	nc,PMReDisplay
	ld	d,1
	jp	PMReDisplay
PMKBUp:
	dec	d
	jp	nz,PMReDisplay
	ld	d,PMNbEntry
	jp	PMReDisplay

;IN : d = BBM# 1->4
;out : hl=(BBMType)
PMFindTypeNum:
	push	bc
	push	de
	ld	h,d
	ld	l,SizeBBM
	ROM_CALL(HTIMESL)
	ld	de,BBM1 + BBMType - SizeBBM
	add	hl,de
	pop	de
	pop	bc
	ret

LevelMenu:
	ld	d,1
LMCleanDisplay:
	call	CR_GRBCopy		;delete menu
LMReDisplay:
	ld	hl,SZLMPlay
	ld	b,LMNbEntry
	ld	c,d
	ld	a,24h
LMLoop:
	ld	(CURSOR_Y),a
	ld	a,0ah
	ld	(CURSOR_X),a
	push	de
	ld	a,6			;big space (4px)
	dec	c
	jr	nz,LMNoCur
	ld	a,b
	cp	1			;it's the level selector
	ld	a,0cfh			;'<' (4px)
	jr	z,LMNoCur
	ld	a,(CURSOR_X)
	inc	a
	ld	(CURSOR_X),a	
	ld	a,0c1h			;'[' (3px)
LMNoCur:
	ROM_CALL(M_CHARPUT)		;destroys DE
	ROM_CALL(D_ZM_STR)
	ld	a,b
	cp	1			;it's the level selector
	jr	nz,LMDrawLastCur
	ld	hl,(Level)		;we can do it because it's at the end of the menu, else we would have had to save hl
	ROM_CALL(D_ZM_STR)
LMDrawLastCur:
	ld	a,6			;big space
	inc	c
	dec	c
	jr	nz,LMNoCur2
	ld	a,b
	cp	1			;it's the level selector
	ld	a,5h			;'>'
	jr	z,LMNoCur2
	ld	a,']'
LMNoCur2:
	ROM_CALL(M_CHARPUT)
	pop	de
	ld	a,(CURSOR_Y)
	add	a,9h
 	djnz	LMLoop
LMKeyLoop:
	halt
	call	GET_KEY
	cp	G_DOWN
	jr	z,LMKBDown
	cp	G_UP
	jr	z,LMKBUp
	cp	G_LEFT
	jr	z,LMDec
	cp	G_RIGHT
	jr	z,LMInc
	cp	G_ENTER
	jr	z,LMSelect
;	cp	G_2ND
;	jr	z,LMSelect
	cp	G_MODE
	jp	z,PlayerMenu
	jr	LMKeyLoop
LMSelect:
;;	ld	a,d
;;	cp	1
;;	jr	nz,LMKeyLoop
	jr	GameStart

LMDec:
	ld	a,d
	cp	LMNbEntry
	jr	nz,LMKeyLoop

	ld	bc,(Level)
	call	LMSeekLevel
	ld	bc,FakeFAT
	call	CP_HL_BC
	jr	z,LMKeyLoop
	dec	hl
	dec	hl
	call	LD_HL_MHL
	ld	(Level),hl
	jp	LMCleanDisplay
LMInc:
	ld	a,d
	cp	LMNbEntry
	jr	nz,LMKeyLoop

	ld	bc,(Level)
	call	LMSeekLevel
	ld	bc,FakeFATEnd
	call	CP_HL_BC
	jr	nc,LMKeyLoop
	inc	hl
	inc	hl
	call	LD_HL_MHL
	ld	(Level),hl
	jp	LMCleanDisplay
LMKBDown:
;	inc	d				;both do the same thing
;	ld	a,LMNbEntry
;	cp	d
;	jp	nc,LMReDisplay
;	ld	d,1
;	jp	LMReDisplay
LMKBUp:
;	dec	d
;	jp	nz,LMReDisplay
;	ld	d,LMNbEntry
	ld	a,00000011b			;1 or 2
	xor	d
	ld	d,a
	jp	LMReDisplay

;IN : bc=*Level
;Out: hl=*in FakeFAT of the Level	bc=*Level
;Be careful:if it doesn't exist it stays in the loop
LMSeekLevel:
	ld	hl,FakeFAT
LMSLLoop:
	push	hl
	call	LD_HL_MHL
	call	CP_HL_BC
	pop	hl
	ret	z
	inc	hl
	inc	hl
	jr	LMSLLoop

ContinueGame:
;;;;

;What we need at the beginning of a game
GameStart:
;	ld	hl,0006h		;to be a Zstring and to draw a big blank
;	ld	(StringTemp-1),hl
	ld	a,6			;to draw a big blank at the end of the time
	ld	(StringTemp-1),a
	ld	hl,0
	ld	(GameWon),hl
	ld	(GameWon +2),hl

;What we need at the beginning of a battle (several in a game)
BattleStart:
	set	7,(iy + 14h)		;write to graph

;we compute the GameState
ComputeGameState:
	ld	hl,BBM4 + BBMType
	ld	de,-SizeBBM
	ld	b,4
CGSLoop:
	ld	a,(hl)
	or	a
	jr	nz,CGSThisBBM	
	scf
CGSThisBBM:
	push	hl
	ld	hl,PlayersState
	rl	(hl)
	pop	hl
	cp	TypeLK
	jr	nz,CGSEnd
	ld	(Linked),a
CGSEnd:
	add	hl,de
	djnz	CGSLoop

GameDuration	= $ + 1
	ld	l,150
	ld	h,fRAMEpERsEC
	ROM_CALL(HTIMESL)		;slow but small
	inc	hl
	inc	hl			;to sync with the redrawing of the time
	ld	(GameTimer),hl
		;Set all variables of level
	ld	hl,(Level)
	xor	a
	cpir
	inc	hl
	ld	a,4
	ld	de,BBM1
GSStateLoop:
	ld	bc,SizeBBMLvl
	ldir
	inc	de			;avoid to write the data that isn't included!
	inc	de
	inc	de
	inc	de
	dec	a
	jr	nz,GSStateLoop

;load the sprites
	ld	hl,SprBBM1
	ld	(BBM1 + BBMSprPtr),hl
	ld	hl,SprBBM2
	ld	(BBM2 + BBMSprPtr),hl
	ld	hl,SprBBM3
	ld	(BBM3 + BBMSprPtr),hl
	ld	hl,SprBBM4
	ld	(BBM4 + BBMSprPtr),hl

	ld	hl,GRAPH_MEM
	ld	de,GRAPH_MEM + 1
	ld	(hl),0
	ld	bc,2ffh
	ldir

	ld	hl,BATStart
	ld	de,BATStart + 1
	ld	(hl),0
	ld	bc,SizeBAT - 1
	ldir

	ld	hl,GRAPH_MEM + (12 * 56)		; a nice black line
	ld	de,GRAPH_MEM + (12 * 56) + 1
	ld	(hl),0ffh
	ld	bc,11
	ldir

;Copy the level data (*Level) into the level buffer (LvlBuf) and compute all the stuff that are random in the data
CopyLvl:
	xor	a
	ld	hl,(Level)
	cpir					;bc = (1)0000h
	ld	de,(4 * SizeBBMLvl) + 1
	add	hl,de
	ex	de,hl
	ld	hl,LvlBuf
	ld	bc,9*15
;	ld	de,(Level)			;;should be based on a pointer to beggining of the entire level, not the map
CLLoop:	ld	a,(de)	
	ld	(hl),a
	and	01110000b			;look at the type of block
	cp	RandBlock
	jr	nz,CLNmlBlk			;nothing special to do
	call	RAND
	and	00000011b
	jr	z,CLNoBlk			;25% are blanks other are bonus
	ld	a,DesBlock - RandBlock		;trasform the block to a destroyable block without having to care about the other bits
	add	a,(hl)
	jr	CLRBEnd
CLNoBlk:
	ld	a,(hl)
	and	10000000b			;Blank block with or without a mask
CLRBEnd:
	ld	(hl),a
CLNmlBlk:
	ld	a,(hl)
	and	00001111b			;;inc	a	;now let's have a look at what the block contains	
	cp	BnRand				;;and	00001111b
	jr	nz,CLNoRand
;75% 00b , 12% 01b , 12% 10b , 1% 11b
	call	RAND
	and	00111111b			;;depends of the nb of Bn
	cp	00011001b
	jr	c,CLRandCorrect			;BnQuicker mustn't be too much
	xor	a
CLRandCorrect:
	and	00011111b			;divided by 2
	sra	a				;;depends of the nb of Bn
	sra	a
	sra	a				;we only need 2 bits
	add	a,(hl)
	sub	BnRand				;hehe
	ld	(hl),a
CLNoRand:
	inc	hl
	inc	de
	dec	bc
	ld	a,b
	or	c
	jr	nz,CLLoop

;now we draw the level on the screen
	ld	bc,0
	ld	hl,LvlBuf
DrwLvl:
	ld	a,(hl)
	push	hl
	bit	7,a
	jr	nz,DrwMask
	and	01110000b
	cp	DesBlock
	jr	z,DrwDBlock
	cp	UndBlock
	jr	z,DrwUBlock
	ld	a,(hl)
	and	00001111b
	jr	z,NextPieceLvl
DrwBn:
	ld	hl,SprBonus - 6
	ld	d,0
	ld	e,a
	rla				;carry reset
	add	a,e
	rla
	ld	e,a			;e= a*6
	add	hl,de
	jr	DrwPieceLvl
DrwUBlock:
	ld	hl,SprUBlock
	jr	DrwPieceLvl
DrwDBlock:
	ld	hl,SprDBlock
	jr	DrwPieceLvl
DrwMask:
	ld	hl,SprMask
DrwPieceLvl:
	push	bc
	call	QuickDraw
	pop	bc
NextPieceLvl:
	pop	hl
	ld	a,b
	add	a,6
	cp	sCREENwIDTH
	jr	nz,NoAddB
	ld	a,c
	add	a,6
	cp	sCREENhEIGHT
	jr	z,FinDrwLvl
	ld	c,a
	xor	a				;;to change the coordinates of the screen
NoAddB:
	ld	b,a
	inc	hl
	jr	DrwLvl
FinDrwLvl:

	ld	a,(PlayersState)
	ld	b,4
	ld	c,0
	ld	ix,BBM1
DrawBBMInfo:
	rra
	jr	c,DBINext
	push	af
	push	ix
	push	bc
	call	DrwBBM				;BBM on the board
	pop	bc
	pop	ix
	push	ix
	push	bc
	ld	hl,TableOfScore
	ld	d,0
	ld	e,c
	add	hl,de
	ld	a,(hl)
	sub	sCREENoRIX + 8
	ld	b,a
	ld	c,3ah - sCREENoRIY		;Bar on the botton
	ld	d,(ix + BBMSprPtr + 1)
	ld	e,(ix + BBMSprPtr)
	ld	hl,6*3				;down
	add	hl,de
	call	QuickDraw			;sprite
	pop	bc
	ld	hl,GameWon
	ld	d,0
	ld	e,c
	add	hl,de
	ld	a,(hl)
	add	a,'0'
	ld	e,4
	add	hl,de
	ld	l,(hl)
	ld	h,39h
	ld	(GRAF_CURS),hl
	ROM_CALL(M_CHARPUT)			;score
	pop	ix
	pop	af
DBINext:
	ld	de,SizeBBM
	add	ix,de
	inc	c
	djnz	DrawBBMInfo

DebBoucleJeu:
BJBBM1:
	ld	a,(PlayersState)
	rra		
	jr	c,BJNoBBM1
	ld	ix,BBM1
	ld	hl,PlayerWorking
	ld	(hl),%00000001
;	ld	a,(GameTimer)			;first byte	;;if has to be faster add this code but it's a little bit less fluent
;	rra
;	call	c,TestKey			;once on 2
	call	TestKey
	call	DeplacBBM
	jr	BJBBM2
BJNoBBM1:
	halt
	halt
BJBBM2:
	ld	a,(PlayersState)
	bit	1,a
	jr	nz,BJNoBBM2
	ld	ix,BBM2
	ld	hl,PlayerWorking
	ld	(hl),%00000010
;	ld	a,(GameTimer)			;first byte	;;if has to be faster add this code but it's a little bit less fluent
;	rra
;	call	c,TestKey			;once on 2
	call	TestKey
	call	DeplacBBM
	jr	BJBBM3
BJNoBBM2:
	halt
	halt
BJBBM3:
	ld	a,(PlayersState)
	bit	2,a
	jr	nz,BJNoBBM3
	ld	ix,BBM3
	ld	hl,PlayerWorking
	ld	(hl),%00000100
;	ld	a,(GameTimer)			;first byte	;;if has to be faster add this code but it's a little bit less fluent
;	rra
;	call	c,TestKey			;once on 2
	call	TestKey
	call	DeplacBBM
	jr	BJBBM4
BJNoBBM3:
	halt
	halt
BJBBM4:
	ld	a,(PlayersState)
	bit	3,a
	jr	nz,BJNoBBM4
	ld	ix,BBM4
	ld	hl,PlayerWorking
	ld	(hl),%00001000
;	ld	a,(GameTimer)			;first byte	;;if has to be faster add this code but it's a little bit less fluent
;	rra
;	call	c,TestKey			;once on 2
	call	TestKey
	call	DeplacBBM
	jr	BJCont
BJNoBBM4:
	halt
	halt

BJCont:
	call	CheckBomb		;;inline
	call	CR_GRBCopy
TestExitKey:
	ld	a,%10111111
	out	($01),a				; Mask out Mode
	in	a,($01)
	bit	6,a
	jr	nz,TestBBMDead
	call	GET_KEY			;to avoid the pushed key is counted in CrASH
	jp	Reboot

TestBBMDead:
	call	CountBBMDead
	cp	3
	jr	c,AddTime
	jr	z,PrepareEnd		;;
	jr	EndDraw

PrepareEnd:
	ld	hl,(GameTimer)
	ld	de,40h
	call	CP_HL_DE
	jr	c,AddTime
	ld	(GameTimer),de

AddTime:
;;Flash the screen when small?
	ld	hl,(GameTimer)
	dec	hl
	ld	(GameTimer),hl
	ld	a,l
	or	h			;h=0 and l=0 <=> (l or h)=0
	jr	z,EndGame
ContTime:
	ld	a,fRAMEpERsEC
	call	DIV_HL_A
	dec	a
	jp	nz,DebBoucleJeu		; only once every sec
	call	CountBBMDead
	cp	3
	jr	nc,DontWriteTime
	ld	de,392Ah
	ld	(GRAF_CURS),de
;DISP_HL	;the famous routine but I don't know who wrote it!?	;;use disp hl?
	ld de,StringTemp - 1
	call	MDHLRepeat
;DHLRepeat:
;	call UNPACK_HL
;	add a,'0'
;	dec de
;	ld (de),a
;	ld a,h
;	or l
;	jr nz,DHLRepeat
;	ex de,hl
;	ROM_CALL(D_ZM_STR)
DontWriteTime:
	jp	DebBoucleJeu
EndGame:
	call	CountBBMDead
	cp	3
	jr	c,EndTime
	jr	z,EndWin
;	jp	EndDraw

EndDraw:
	ld	hl,$0303
WriteDraw:
	ld	(CURSOR_POS),hl
	ld	hl,SZEndDraw
        ROM_CALL(D_ZT_STR)
	ld	a,40h			;reset the screen as it is normaly in case we've stoped in an explosion
	out	(P_LCD_CON),a
KeyEndBattle:
	call	CR_KHAND
	cp	K_MODE
	jp	z,Reboot
	cp	K_ENTER
	jr	nz,KeyEndBattle
	jp	BattleStart

EndTime:
	ld	hl,$0303
	ld	(CURSOR_POS),hl
	ld	hl,SZEndTime
        ROM_CALL(D_ZT_STR)
	ld	hl,$0304
	jr	WriteDraw

EndWin:
	ld	hl,$0604
	ld	(CURSOR_POS),hl
	ld	hl,SZEndWin
        ROM_CALL(D_ZT_STR)
	ld	hl,$0403
	ld	(CURSOR_POS),hl
	ld	hl,SZPlayer
        ROM_CALL(D_ZT_STR)
	ld	de,(PlayersState)	;just e
	ld	hl,GameWon - 1
	xor	a
EWCountLoop:
	inc	a
	rr	e
	inc	hl
	jr	c,EWCountLoop
	add	a,'0'
	ROM_CALL(TR_CHARPUT)		;player number
	inc	(hl)
	ld	a,(hl)
	push	af
	add	a,'0'
	ld	de,4			;now we are in TableOfScore
	add	hl,de
	ld	l,(hl)
	ld	h,39h
	ld	(GRAF_CURS),hl
	res	7,(iy + 14h)		;write directly to LCD
	ROM_CALL(M_CHARPUT)		;new score
	pop	af			;needed because of M_CHARPUT
;	sub	'0'
NbOfGameToWin	= $ + 1
	cp	3
	jr	c,KeyEndBattle
	ld	hl,$0404
	ld	(CURSOR_POS),hl
	ld	hl,SZGameWon
        ROM_CALL(D_ZT_STR)
	ld	a,40h			;reset the screen as it is normaly in case we've stoped in an explosion
	out	(P_LCD_CON),a
KeyEndGame:
	call	CR_KHAND
	cp	K_MODE
	ret	z
	cp	K_ENTER
	jr	nz,KeyEndGame
	jp	Reboot


;ix=BBM
CreateBomb:
	ld	a,(ix + BBMDir)		;mustn't move
	or	a
	ret	nz
	ld	a,(ix + BBMRem)
	or	a
	ret	z
	ld	c,(ix + BBMY)
	ld	b,(ix + BBMX)
	ld	h,b
	ld	l,c
	call	GetAddressInLvl
	ld	a,(hl)
	and	01100000b
	cp	Bomb
	ret	z
	dec	(ix + BBMRem)
	push	hl
	push	bc
	ld	hl,BATStart + BbTimer - SizeBb
	ld	bc,SizeBb
	xor	a
	ld	e,-1
CBLoopFindBlank:
	inc	e
	add	hl,bc			;;perhaps chk if it's over the BAT
	cp	(hl)
	jr	nz,CBLoopFindBlank
	ld	(hl),50h		;BbTimerMax
	pop	bc
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	a,(PlayerWorking)
	ld	d,-1
CBBBMNb:
	inc	d
	rra
	jr	nc,CBBBMNb
	ld	a,(ix + BBMExp)
	sla	a
	rla
	or	d
	inc	hl
	ld	(hl),a
	pop	hl
	ld	a,(hl)
	and	HIDDEN
	or	e			;nb of the bomb
	or	Bomb
	ld	(hl),a
	ld	hl,SprBomb
	push	ix
	call	PutSprClpXOR
	pop	ix
	ret

;hl= Bomb in BAT
ExpendBomb:
	inc	hl			;Update ix
	inc	hl
	inc	hl
	ld	a,(hl)
	ld	c,a
	and	00000011b
	inc	a
	ld	b,a
	ld	ix,BBM1 - SizeBBM
	ld	de,SizeBBM
EBBBMFind:
	add	ix,de
	djnz	EBBBMFind
	sra	c
	sra	c
	ld	b,c			;b=c=BBMExp
	push	bc
	inc	(ix + BBMRem)
	dec	hl			;to destroy the bomb itself
	dec	hl
	call	LD_HL_MHL
	push	hl		
	call	GetAddressInLvl
	ld	a,(hl)
	and	00011111b
	ld	e,a			;save the nb of the bomb
	ld	a,HIDDEN
	and	(hl)
	ld	(hl),a
	pop	hl

	push	de
	push	hl
	call	SetFireInSquare
	pop	hl
	pop	de
	pop	bc
					;;Should be a routine ?
	push	de
	push	hl
ExpdBbUp:
	ld	a,l
	or	a
	jr	z,ExpdBbDownIni		;Out of the screen
	sub	6
	ld	l,a
	push	bc
	push	de
	push	hl
	call	SetFireInSquare
	pop	hl
	pop	de
	pop	bc
	or	a
	jr	z,ExpdBbDownIni
	djnz	ExpdBbUp

ExpdBbDownIni:
	pop	hl
	pop	de
	ld	b,c
	push	de
	push	hl
ExpdBbDown:
	ld	a,l
	cp	8*6
	jr	z,ExpdBbLeftIni		;Out of the screen
	add	a,6
	ld	l,a
	push	bc
	push	de
	push	hl
	call	SetFireInSquare
	pop	hl
	pop	de
	pop	bc
	or	a
	jr	z,ExpdBbLeftIni
	djnz	ExpdBbDown

ExpdBbLeftIni:
	pop	hl
	pop	de
	ld	b,c
	push	de
	push	hl
ExpdBbLeft:
	ld	a,h
	or	a
	jr	z,ExpdBbRightIni	;Out of the screen
	sub	6
	ld	h,a
	push	bc
	push	de
	push	hl
	call	SetFireInSquare
	pop	hl
	pop	de
	pop	bc
	or	a
	jr	z,ExpdBbRightIni
	djnz	ExpdBbLeft

ExpdBbRightIni:
	pop	hl
	pop	de
	ld	b,c
ExpdBbRight:
	ld	a,h
	cp	6*14
	jr	z,ExpdBbEnd		;Out of the screen
	add	a,6
	ld	h,a
	push	bc
	push	de
	push	hl
	call	SetFireInSquare
	pop	hl
	pop	de
	pop	bc
	or	a
	jr	z,ExpdBbEnd
	djnz	ExpdBbRight
	
ExpdBbEnd:
	ret


;IN: hl=XY in Graph	e=Nb of the bomb
;RETURN: a is null if the line of bombing must stop(collision) ;;why not a flag
SetFireInSquare:
	push	de
	ld	de,(PlayersState)	;only for e
	ld	bc,(BBM1+BBMPos)
	call	CpFireWithBBM
	call	z,BBM1Dead
	ld	bc,(BBM2+BBMPos)
	call	CpFireWithBBM
	call	z,BBM2Dead
	ld	bc,(BBM3+BBMPos)
	call	CpFireWithBBM
	call	z,BBM3Dead
	ld	bc,(BBM4+BBMPos)
	call	CpFireWithBBM
	call	z,BBM4Dead

SFISTstCase:
	push	hl
	call	GetAddressInLvl
	ld	a,(hl)
	and	01110000b
	pop	bc			;ld	hl,bc
	pop	de			;from the begining of the routine
	cp	DesBlock
	jr	z,SetFireBlock
	cp	FiredBlock
	jr	z,LineFinished
	cp	UndBlock
	jp	z,LineFinished		;;
	and	01100000b
	cp	Fire
	jr	z,AlreadyFire
	cp	Bomb
	jr	z,ExpendOtherBomb
SetFire:
	ld	a,(hl)
	and	00001111b
	jr	z,SFBnNull
	bit	7,(hl)
	jr	nz,SFBnNull
	push	de
	push	hl
	ld	hl,SprBonus - 6
	ld	e,a
	rla				;carry	reset by and
	add	a,e
	rla
	ld	e,a
	ld	d,0
	add	hl,de
	push	bc
	call	QuickDraw
	pop	bc
	pop	hl
	pop	de
SFBnNull:
	ld	a,(hl)
	and	HIDDEN
	or	e
	or	Fire
	ld	(hl),a
	bit	7,a
	ret	nz			; a !=0 => OK
	ld	hl,SprFire
	call	QuickDraw
	ld	a,1			;;needed?
	ret

AlreadyFire:
	ld	a,(hl)
	and	11100000b
	or	e
	ld	(hl),a
;	ld	a,1			;;a is <> 0 already, isn't it?
	ret

SetFireBlock:
	ld	a,(hl)
	add	a,FiredBlock - DesBlock
	ld	(hl),a
LineFinished:
	xor	a
	ret

ExpendOtherBomb:
	ld	a,(hl)
	and	00011111b
	rla				;carry is reset
	rla
	ld	e,a
	ld	d,0
	ld	hl,BATStart + BbTimer
	add	hl,de
	ld	a,(hl)			;save the previous Timer to know if the bomb is drawn or not
	cp	12
	jr	c,EOBDontChangeTimer
	ld	(hl),11
EOBDontChangeTimer:
	cp	bOMBfLASH
	jr	nc,EOBRemoveSprBomb
	bit	2,a			;set=> blank (if a<bOMBfLASH)
	jr	z,DontNeedToRmvBmb

EOBRemoveSprBomb:
	inc	hl
	ld	c,(hl)			;BbY
	inc	hl
	ld	b,(hl)			;BbX
	ld	hl,SprBomb
	call	PutSprClpXOR
DontNeedToRmvBmb:
	xor	a			;ld	a,1			;;needed?
	ret

BBM1Dead:
	ld	a,%00000001
	jr	BBMDeadEnd
BBM2Dead:
	ld	a,%00000010
	jr	BBMDeadEnd
BBM3Dead:
	ld	a,%00000100
	jr	BBMDeadEnd
BBM4Dead:
	ld	a,%00001000
BBMDeadEnd:
	push	hl
	push	de
	ld	hl,PlayersState
	push	af
	or	(hl)
	ld	(hl),a
	pop	af
	ld	ix,BBM1 - SizeBBM
	ld	de,SizeBBM
BBMDFindIt:
	add	ix,de
	rra
	jr	nc,BBMDFindIt
	push	af
	call	DrwBBM
	pop	af
	pop	de
	pop	hl
	ret	


;c=Nb of the bomb
EndOfFire:
	ld	d,0		;1 if there are still some fires
	ld	hl,LvlBuf
	ld	b,9*15
	ld	a,c
	or	Fire
	ld	c,a
EOFRepeatBlock:
	ld	a,(hl)
	and	01111111b
	cp	c
	jr	z,EOFDelBlock
	and	01100000b
	cp	Fire
	jr	nz,EOFNextBlock
	inc	d
	jr	EOFNextBlock
EOFDelBlock:
	push	hl
	ld	a,(hl)
	and	10000000b
	ld	(hl),a
	jr	nz,EOFHidden
	push	bc
	push	de
	call	ConvLBToXY
	ld	b,h
	ld	c,l
	ld	hl,SprFire		;;
	call	QuickDraw
	pop	de
	pop	bc
EOFHidden:	
	pop	hl
EOFNextBlock:
	inc	hl
	djnz	EOFRepeatBlock
	ld	a,d
	or	a
	ret	nz
PutBonus:
	ld	hl,LvlBuf
	ld	b,9*15
PBRepeatFire:
	ld	a,(hl)
	and	01110000b
	cp	FiredBlock
	jr	nz,PBNextSquare
	ld	a,(hl)
	and	10001111b
	ld	(hl),a
	bit	7,a
	jr	nz,PBNextSquare
	push	bc
	push	hl
	ld	b,a			;save a
	call	ConvLBToXY
	ld	a,b			;restore a
	ld	b,h
	ld	c,l
	and	00001111b
	jr	z,PBBlank
	ld	hl,SprBonus - 6
	ld	e,a
	sla	a
	add	a,e			;carry reset
	rla
	ld	e,a			;e= a*6
	ld	d,0
	add	hl,de
	push	bc
	call	QuickDraw
	pop	bc
PBBlank:
	ld	hl,SprDBlock
	call	QuickDraw
	pop	hl
	pop	bc
PBNextSquare:
	inc	hl
	djnz	PBRepeatFire
	ret


CheckBomb:
	ld	hl,BATStart + BbTimer - SizeBb
	ld	de,SizeBb
	ld	b,(SizeBAT / SizeBb)+ 1
	ld	c,0ffh
CBNextBomb:
	xor	a
CBLoopNull:
	dec	b
	ret	z
	add	hl,de
	inc	c
	cp	(hl)
	jr	z,CBLoopNull

	dec	(hl)			;BbTimer
	ld	a,(hl)
	cp	bOMBfLASH
	jr	nc,CBNextBomb
	cp	8		;;
	jr	nz,CBDontExp
	push	bc
	push	de
	push	hl
	ld	a,40h + 4		;scroll the screen to simulate explosion
	out	(P_LCD_CON),a
	call	ExpendBomb
	pop	hl
	pop	de
	pop	bc
	jr	CBNextBomb
CBDontExp:
	cp	5			;;6
	jr	nz,CBDontScrollScreen
	ld	a,40h - 2 + 64
	out	(P_LCD_CON),a
CBDontScrollScreen:
	cp	3			;;4
	jr	nz,CBDontResetScreen
	ld	a,40h			;reset the screen as it was before the explosion
	out	(P_LCD_CON),a
CBDontResetScreen:
	or	a
	jr	nz,BombTFlash
	push	bc
	push	de
	push	hl
	call	EndOfFire
	pop	hl
	pop	de
	pop	bc
	jr	CBNextBomb
BombTFlash:
	cp	8
	jr	c,CBNextBomb
	inc	a			;;
	and	%00000011		;modulo 4
	jr	nz,CBNextBomb
BombTInvert:
	push	bc
	push	de
	push	hl
	inc	hl
	ld	c,(hl)			;BbY
	inc	hl
	ld	b,(hl)			;BbX
	ld	hl,SprBomb
	call	PutSprClpXOR
	pop	hl
	pop	de
	pop	bc
	jr	CBNextBomb

;ix=BBM
TestKey:
	ld	a,(ix + BBMType)
	cp	TypeOC1		;; could use dec a
	jr	z,TKOC1
	cp	TypeOC2
	jr	z,TKOC2
	cp	TypeAI1
	jr	z,TKAI1
	cp	TypeAI2
	jr	z,TKAI2
TKLink:
	ld	a,0ffh		;;should be a link routine
	halt
	;call	ReceiveByte
	jp	TKKeyReceivedNoLink

TKAI1:					; easy AI routine ;awfull
	ld	a,(ix + BBMDir)
	or	a
	ld	a,0ffh
	jr	nz,TKAI1End
	call	RAND
	ld	b,a
	rl	b
	or	b
	rl	b
	or	b
	rl	b
	or	b
	or	10110000b		;mask
TKAI1End:
	jr	TKKeyReceived

TKAI2:
	ld	a,0ffh		;;should be a better AI routine
	halt
	jr	TKKeyReceived

TKOC1:		;arrows + ( clear + 2nd )
	ld	a,0ffh				; reset keyport	;Thank you Harper Maddox (from Chicken)
	out	(P_KEYBOARD),a			; necessary code
	ld	a,%11111110
	out	(P_KEYBOARD),a			; Mask out Arrows
	in	a,(P_KEYBOARD)
	ld	b,a
						;; no need to reset
	ld	a,%11111101
	out	(P_KEYBOARD),a			; Mask out Clear
	in	a,(P_KEYBOARD)
	or	10111111b
	and	b
	ld	b,a
	ld	a,0ffh				; reset keyport
	out	(P_KEYBOARD),a
	ld	a,%10111111
	out	(P_KEYBOARD),a			; Mask out 2nd
	in	a,(P_KEYBOARD)
	rla
	or	10111111b
	and	b
	jr	TKKeyReceived

TKOC2:		;Sto>:right 4:Left 0:down 2:up  +  '.'
	ld	a,0ffh				; reset keyport
	out	(P_KEYBOARD),a
	ld	b,a				; reset the keys
	ld	a,%11110111
	out	(P_KEYBOARD),a			; Mask out '.'/2
	in	a,(P_KEYBOARD)
	bit	0,a
	jr	nz,TKOC2NoBomb
	res	6,b
TKOC2NoBomb:
	bit	1,a
	jr	nz,TKOC2Cont
	res	2,b
TKOC2Cont:	
	ld	a,0ffh				; reset keyport
	out	(P_KEYBOARD),a
	ld	a,%11101111
	out	(P_KEYBOARD),a			; Mask out 0/4
	in	a,(P_KEYBOARD)
	bit	0,a				;;
	jr	nz,TKOC2NoDown
	res	0,b
TKOC2NoDown:
	bit	2,a
	jr	nz,TKOC2Cont2
	res	3,b
TKOC2Cont2:
	ld	a,0ffh				; reset keyport
	out	(P_KEYBOARD),a
;	ld	a,%11101111			;1 :for emulator
	ld	a,%11011111
	out	(P_KEYBOARD),a			; Mask out sto>
	in	a,(P_KEYBOARD)
	bit	1,a				;;
	jr	nz,TKOC2End
	res	1,b
TKOC2End:
	ld	a,b
;	jr	TKKeyReceived

TKKeyReceived:
;in a:
;bit 0 res = down
;bit 1 res = left
;bit 2 res = right
;bit 3 res = up
;bit 4 not used
;bit 5 not used
;bit 6 res = Bomb
;bit 7 not used

	ld	b,a
	ld	a,(Linked)
	or	a
	ld	a,b
	jr	z,TKKeyReceivedNoLink
	;call	sendbyte

TKKeyReceivedNoLink:
	push	af
	bit	6,a
	call	z,CreateBomb		;;inline
	pop	af
	or	(ix + BBMDir)		;Compatible with the current dpl ?

	rrca
	jr	nc,DownBBM
	rrca
	jr	nc,LeftBBM
	rrca
	jr	nc,RightBBM
	rrca
	ret	c

UpBBM:
	ld	a,(ix + BBMY)
	or	a
	ret	z
	ld	b,%00001110		;Mask for Down
	ld	de,-6
	jr	FinTestKey

DownBBM:
	ld	a,(ix + BBMY)
	cp	sCREENhEIGHT - 6
	ret	z
	ld	b,%00000111		;Mask for Up
	ld	de,6
	jr	FinTestKey

LeftBBM:
	ld	a,(ix + BBMX)
	or	a
	ret	z
	ld	b,%10001011		;Mask for Right
	ld	de,-600h
	jr	FinTestKey

RightBBM:
	ld	a,(ix + BBMX)
	cp	sCREENwIDTH - 6
	ret	z
	ld	b,%10001101		;Mask for Left
	ld	de,600h

FinTestKey:
	call	IsCasePossible
	ld	(ix + BBMDir),b
	ret


;ix=BBM		b=FutureDpl	de=mvt
;returns b as new Dpl
IsCasePossible:
	ld	a,(ix + BBMDir)		;Dpl?
	or	a
	ret	nz			;It has been possible so it's possible
	ld	l,(ix + BBMY)
	ld	h,(ix + BBMX)
NextIP:
	add	hl,de
	call	GetAddressInLvl
	ld	a,(hl)
	and	01110000b
	jr	z,ICPBonus
	cp	FiredBlock
	jr	z,NotPossible
	cp	DesBlock
	jr	z,NotPossible
	cp	UndBlock
	jr	z,NotPossible
	and	01100000b
	cp	Bomb
	jr	z,NotPossible
	cp	Fire
	ret	nz
KillBBMIP:
	ld	a,(PlayerWorking)
	ld	hl,PlayersState
	or	(hl)
	ld	(hl),a
	push	ix
	call	DrwBBM
	pop	ix
NotPossible:
	ld	b,0
	ret
ICPBonus:
	ld	a,(hl)
	ld	(hl),0
	bit	7,a
	jr	z,ICPTstBn
	ld	(hl),HIDDEN
ICPTstBn:
	and	00001111b
	ret	z
	push	bc
	push	ix
	cp	BnMoreBb		;;dec	a
	jr	z,ICPMoreBb
	cp	BnMoreExp		;;dec	a
	jr	z,ICPMoreExp
	cp	BnQuicker		;;dec	a
	jr	z,ICPQuicker
	cp	BnSupBomb
	jr	z,ICPSupBomb

ICPSupBomb:
	set	2,(ix + BBMBn)
	call	ConvLBToXY
	ld	b,h
	ld	c,l
	ld	hl,SprBnSupBomb
	jr	ICPEraseBn
ICPQuicker:
	bit	1,(ix + BBMBn)
	jr	nz,ICPQNoAdd
	inc	(ix + BBMBn)
ICPQNoAdd:
	call	ConvLBToXY
	ld	b,h
	ld	c,l
	ld	hl,SprBnQuicker
	jr	ICPEraseBn
ICPMoreExp:
	inc	(ix + BBMExp)
	call	ConvLBToXY
	ld	b,h
	ld	c,l
	ld	hl,SprBnMoreExp
	jr	ICPEraseBn
ICPMoreBb:
	inc	(ix + BBMRem)
	call	ConvLBToXY
	ld	b,h
	ld	c,l
	ld	hl,SprBnMoreBb
ICPEraseBn:
	call	PutSprClpXOR
	pop	ix
	pop	bc
	ret


;ix = BBM
DeplacBBM:
	ld	a,(ix + BBMDir)		;dpl?
	or	a
	jr	nz,IsMoving
	halt				;It must be slow down to compensate
	ret
IsMoving:
	push	af
	push	hl
	push	ix
	call	DrwBBM
	pop	ix
	pop	hl
	pop	af

	ld	(ix + BBMOldDir),a
	rrca
	jr	nc,UpDplBBM
	rrca
	jr	nc,RightDplBBM
	rrca
	jr	nc,LeftDplBBM
DownDplBBM:
	ld	a,(ix + BBMBn)
	and	00000011b
	inc	a
	add	a,(ix + BBMY)
	ld	(ix + BBMY),a
	ld	c,a
	ld	b,(ix + BBMX)
	jr	FinDplBBM

UpDplBBM:
	ld	a,(ix + BBMBn)
	and	00000011b
	inc	a
	sub	(ix + BBMY)
	neg
	ld	(ix + BBMY),a
	ld	c,a
	ld	b,(ix + BBMX)
	jr	FinDplBBM
	
RightDplBBM:
	ld	a,(ix + BBMBn)
	and	00000011b
	inc	a
	add	a,(ix + BBMX)
	ld	(ix + BBMX),a
	ld	b,a
	ld	c,(ix + BBMY)
	jr	FinDplBBM
	
LeftDplBBM:
	ld	a,(ix + BBMBn)
	and	00000011b
	inc	a
	sub	(ix + BBMX)
	neg
	ld	(ix + BBMX),a
	ld	b,a
	ld	c,(ix + BBMY)

FinDplBBM:
	push	af
	push	ix
	call	DrwBBMPos
	pop	ix
	pop	af
	ld	l,a
	call	L_by_6			;modulo 6
	or	a
	ret	nz
	ld	(ix + BBMDir),a		;a = 0
	ret

;out : a= number of BBMs dead	b is destroyed
CountBBMDead:
	ld	a,(PlayersState)
	ld	b,a
	xor	a
	rr	b
	adc	a,0
	rr	b
	adc	a,0
	rr	b
	adc	a,0
	rr	b
	adc	a,0
	ret

;return z if BBM is in the same square than Fire (in fact it can be what you want) (at about 3px)
;IN : hl=XY of Fire    bc=Pos of BBM  e= LSB = player state
;return e >>1 destroy bc
CpFireWithBBM:
	rrc	e
	bit	7,e
	ret	nz			;don't check a dead man
	push	hl
	ld	a,b
	add	a,3			;check the middle of BBM
	ld	l,a
	call	L_by_6
	ld	a,l
	sla	a
	add	a,l
	rla				;at about 3
	ld	b,a
	ld	a,c
	add	a,3
	ld	l,a
	call	L_by_6
	ld	a,l
	sla	a
	add	a,l
	rla
	ld	c,a
	pop	hl
	call	CP_HL_BC
	ret

;hl=XY in Graph		[adefhl]
;return hl in LvlBuf	d=0  , a=e=byte in level , Z=0 C=0
GetAddressInLvl:
	call	L_by_6
	ld	a,l
	sla	a
	rla
	rla
	rla
	sub	l			;a=15(Y/6)=16(Y/6)-(Y/6) at about 6
	ld	e,a
	ld	l,h
	call	L_by_6
	ld	a,l			;a=X/6
	add	a,e
	ld	e,a
	ld	d,0
	ld	hl,LvlBuf
	add	hl,de
	ret

;hl points in LvlBuf	[adefhl]
;return hl = XY in Graph 
ConvLBToXY:
	ld	de,LvlBuf
	or	a			;reset carry flag
	sbc	hl,de
	ld	a,15
	call	DIV_HL_A
	ld	d,a
	sla	a
	add	a,d
	rla
	ld	h,a
	ld	a,l
	rla
	add	a,l
	rla
	ld	l,a
	ret

;to display HL in a menu char done by I don't know who :-(
;in : hl= nb to display + GRAF_CURS + destroys de
M_HL_DECI:
	ld	de,StringTemp
MDHLRepeat:
	call	UNPACK_HL
	add	a,'0'
	dec	de
	ld	(de),a
	ld	a,h
	or	l
	jr	nz,MDHLRepeat
	ex	de,hl
	ROM_CALL(D_ZM_STR)
	ret


;return L=int(L/6), A=L MOD 6  [afl]
;flags: Z=1
L_by_6:
        ld      a,6
L_by_A:		;return L=int(L/A), A=L MOD A  [afl]	;algorithm of ti
        push    bc
        ld      c,a
        xor     a
        ld      b,8
Lb6Loop:
	sla	l
        rla     
        cp      c
        jr      c,Lb6NotStill
        sub     c
        inc     l
Lb6NotStill:
	djnz    Lb6Loop
	pop     bc
	ret


QDXSpriteHeight	= 6
;----------------------------------------------------------------------------
;[ QuickDraw ] [ABCDEFIX]                [ modified by Eric to fit the prog ]
; was
;[ PutSprClpXOR ] [ABCDEFIX]                                    [ CrASH_Man ]
;----------------------------------------------------------------------------
; Draws a sprite using only XOR data
;
; parameters: HL -> sprite, (B,C) = coordinates
; returns:    Puts sprite in GRAPH_MEM
;
QuickDraw:
		PUSH HL				; IX -> Sprite
                POP  IX
		ld	a,c
		add	a,sCREENoRIY
		ld	c,a
		ld	a,b
		add	a,sCREENoRIX
		ld	b,a
		LD   B, 0
                LD   H, B
                LD   L, C
                ADD  HL, BC			; HL = Y * 12
                ADD  HL, BC
                ADD  HL, HL
                ADD  HL, HL

                LD   C, A			; HL = Y*12 + X/8
                SRA  C
                SRA  C
                SRA  C
;                INC  C				;done by  LD   BC, GRAPH_MEM + 1

                ADD  HL, BC
                LD   BC, GRAPH_MEM + 1
                ADD  HL, BC

                LD   B, QDXSpriteHeight		; B = number of rows

                CPL
                AND  %00000111			; find number of
                LD   E, A			; instructions to jump
                ADD  A, E
                ADD  A, E
                LD   (_QD_OPchg + 1), A		; 3 * (7 - number)

		LD   DE, 13

_QD_LineLoop:	
		LD   C, (IX)
                XOR  A
_QD_OPchg:	JR   _QD_OPchg			; modify

                RR   C
                RRA
                RR   C
                RRA
                RR   C
                RRA
                RR   C
                RRA
                RR   C
                RRA
                RR   C
                RRA
                RR   C
                RRA

                XOR  (HL)			; XOR with background
		LD   (HL), A			; Write
                DEC  HL				; HL -> next 8 pixels

                LD   A, C
                XOR  (HL)			; XOR with background
		LD   (HL), A			; Write
                ADD  HL, DE			; HL -> next row

                INC  IX				; Increment to next data
                DJNZ _QD_LineLoop
                RET



;;;; IN: IX= pointer to BBM
;   OUT: BBM drawn with dir and clipping
;DESTROY abcdefhlix
DrwBBM:
	ld	b,(ix + BBMX)
	ld	c,(ix + BBMY)
DrwBBMPos:	;IN :BC = coordinates IX= pointer to BBM
	ld	d,(ix + BBMSprPtr +1)
	ld	e,(ix + BBMSprPtr)
DrwBBMPosPtr:	;IN :BC = coordinates  DE= Pointer to sprite IX= pointer to BBM
	ld	l,(ix + BBMOldDir)
DrwBBMPosPtrDir:	;IN :BC = coordinates  DE= Pointer to sprite l= dir
	ld	a,-6
DBContDir:
	add	a,6
	sra	l
	jr	c,DBContDir
	ld	h,0
	ld	l,a
	add	hl,de
;	jp	PutSprClpXOR


ClpXSpriteHeight	= 6
;----------------------------------------------------------------------------
;[ PutSprClpXOR ][ABCDEFIX] [ CrASH_Man ][ modified by Eric to fit the prog ]
;----------------------------------------------------------------------------
; Draws a sprite using only XOR data and clipping
;
;----------------------------------------------------------------------------
;Widely and wildly modified by Eric to fit BMMP : no more clipping on the
;border of the screen but clipping if there is a square masked
;optimisation: clipping both horizontal and vertical cannot exist
;----------------------------------------------------------------------------
;
; parameters: HL -> sprite, (B,C) = coordinates
; returns:    Puts sprite in GRAPH_MEM
;
PutSprClpXOR:		;;6x6
		PUSH	HL				; IX -> Sprite
                POP	IX

		ld	l,b
		call	L_by_6
		or	a
		jr	nz,_SCX_NoVertClp		; not aligned => can't be clipped vertically => go away
		dec	a
		ld	(_SCX_MaskChg +1),a		; a was 0 and we don't want any mask (=1111111b)

		ld	h,b
		ld	a,c
		add	a,ClpXSpriteHeight-1
		ld	l,a
		call	GetAddressInLvl
		ld	a,(hl)
		rla
		LD	DE,ClpXSpriteHeight		; D = 0, E = Height
		JP	nc, _SCX_NoBotClp		; No bottom clip.
		ld	a,c
		add	a,ClpXSpriteHeight-1
		ld	l,a
		call	L_by_6
		neg
		add	a,ClpXSpriteHeight-1
		ret	z				;should speed up all V-aligned sprites
		LD	E, A
_SCX_NoBotClp:

		ld	h,b
		ld	l,c
		push	de
		call	GetAddressInLvl
		pop	de
		ld	a,(hl)
		rla
                JP	nc, _SCX_ClpDone
		ld	l,c
		call	L_by_6
		neg
		add	a,ClpXSpriteHeight		;a = size to not draw
		push	de
		ld	d,0
		ld	e,a
		add	ix,de				;don't want to write the begining of the sprite
		ld	d,a
		add	a,c				; => we have to update the coordinates
		ld	c,a				;new Y
		ld	a,d				
		pop	de
		SUB	E
		ret	z
		NEG
		LD	E, A				;new height
		jr	_SCX_ClpDone

_SCX_NoVertClp: 
		ld	d,b				; save X
		ld	b,a				; b= X % 6
		ld	a,00000011b
_SCX_CreateMask:
		sll	a
		djnz	_SCX_CreateMask			; OK because never V-aligned
		ld	e,a
		push	de
;;		call	GetAddressInLvlMod		;maybe inline
		ld	h,d				;
		ld	l,c				;
		call	GetAddressInLvl			;
		pop	de
		ld	a,(hl)
		rla
		ld	b,e				; save the mask
		jr	c,_SCX_LeftClp
		ld	b,0FFh
_SCX_LeftClp:	inc	hl
		ld	a,(hl)
		rla
		ld	a,0FFh
		jr	nc,_SCX_NoRightClp
		ld	a,e
		cpl					; the opposite part of the mask
_SCX_NoRightClp:
		and	b
		ld	(_SCX_MaskChg +1),a
		ld	b,d				;restore X
		LD	DE,ClpXSpriteHeight		; D = 0, E = Height

_SCX_ClpDone:   
		ld	a,c
		add	a,sCREENoRIY
		ld	c,a
		ld	a,b
		add	a,sCREENoRIX
		ld	b,a
		LD   B, D			; remember? D = 0
                LD   H, B
                LD   L, C
                ADD  HL, BC			; HL = Y * 12
                ADD  HL, BC
                ADD  HL, HL
                ADD  HL, HL

                LD   C, A			; HL = Y*12 + X/8
                SRA  C
                SRA  C
                SRA  C

                ADD  HL, BC
                LD   BC, GRAPH_MEM + 1		; c=+1
                ADD  HL, BC

                LD   B, E			; B = number of rows

                CPL
                AND  %00000111                    ; find number of
                LD   E, A                         ; instructions to jump
                ADD  A, E
                ADD  A, E
                LD   (_SCX_OPchg_3 + 1), A        ; 3 * (7 - number)

                LD   DE, 13

_SCX_LineLoop:	ld	a,(ix)
_SCX_MaskChg:	and	11111111b
		ld	c,a
		xor	a
;or probably better if can change all the other code
;_SCX_LineLoop:	ld	a,(ix)
;_SCX_MaskChg:	and	11111111b
;		ld	c,0
;;;;
_SCX_OPchg_3:   JR   _SCX_OPchg_3			; modify

                RR   C
                RRA
                RR   C
                RRA
                RR   C
                RRA
                RR   C
                RRA
                RR   C
                RRA
                RR   C
                RRA
                RR   C
                RRA

                XOR  (HL)                         ; XOR with background
		LD   (HL), A                      ; Write
                DEC  HL                           ; HL -> next 8 pixels

                LD   A, C
                XOR  (HL)                         ; XOR with background
		LD   (HL), A                      ; Write
                ADD  HL, DE                       ; HL -> next row

                INC  IX                           ; Increment to next data
                DJNZ _SCX_LineLoop
                RET
; DATAs
SZBMMP:		.db "BomberMan",0,"MultiPlayer",0
;main menu
MMNbEntry	= 2
;SZMMCont:	.db "Continue Game",0
SZMMNew:	.db "New Game",0
SZMMOption:	.db "Options",0
;option menu
OMNbEntry	= 2
SZOMNbattle	.db "Battles to win",6,0
SZOMDuration	.db "Duration",6,0
;player menu
PMNbEntry	= 4
SZPMPlayer:	.db "Player ",0			;;
SZPNH:		.db "Rest",0			;in the same order than BBMType
SZPP1:		.db "Keys 1",0
SZPP2:		.db "Keys 2",0
;SZPP3:		.db "Keys 3",0
SZPAI1:		.db "AI",6,"1",0
SZPAI2:		.db "AI",6,"2",0
SZPLink:	.db "Linked",0
;level menu
LMNbEntry	= 2
SZLMPlay:	.db "Play",0
;SZLMTeam:	.db "Team Play",0
SZLMLevel:	.db "Level: ",0
;team menu
SZTMTeam:	.db "Team ",0

SZWaitCalc	.db "Waiting the other calculator",0
UnloadStr	.db "Disable the interrupt",0

SZEndTime:	.db " time up ",0
SZEndDraw:	.db "DRAW GAME",0CEh,0		;CEh=...
SZEndWin:	.db "WoN",0
SZPlayer:	.db "Player ",0
SZGameWon:	.db "VICTORY!!",0


Level:		.dw	LvlSA				;Here for continue game
GameWon:
.db		0,0,0,0

TableOfScore:
.db		0ch,57h,20h,44h		;contains positions of the scores on the board, must be just after GameWon

;GameState:
;.db	0			;Linked
;.db	00001100b		;PlayersState
;GameStateEnd:

#include "graphics.inc"

;Code Block:
Blank		=	00h		;4th Last Signifiant Bits : Bonus
RandBlock	=	10h		;May become a DesBlock or a Blank (without bonus)
FiredBlock	=	10h		;In game means it must be destroyed in few sec
Fire		=	20h		;5LSB : n		only in game
Bomb		=	40h		;5LSB : n		only in game
DesBlock	=	60h		;4LSB : Bonus	
UndBlock	=	70h		;;4LSB : lots of != Graphics?

HIDDEN		=	10000000b	;do a OR with the object to hide it

;Code Bonnus: (on 4 bits => 16 possible types)
BnNull		=	00h	;No bonnus
BnMoreBb	=	01h	;Increase the nb of bomb
BnMoreExp	=	02h	;Increase the expantion of the bombs
BnQuicker	=	03h	;Increase the speed of the BBM
BnSupBomb	=	04h	;Bomb can destroy everything

BnInverted	=	0ah	;Invert the direction of the BBM
BnAI		=	0bh	;Directed by the AI of the calc
BnJam		=	0ch	;Is very slow
BnFlash		=	0dh	;Is very quick
BnLay		=	0eh	;Lay as many bombs as possible

BnRand		=	0fh	;Choosed randomly (doesn't exist once the game is started)

FakeFAT:
.dw	LvlSA,LvlFW,LvlHS,LvlEW,LvlST
FakeFATEnd	= $ - 2

LvlSA:
#include "LvlSA.inc"

LvlHS:
#include "LvlHS.inc"

LvlFW:
#include "LvlFW.inc"

LvlEW:
#include "LvlEW.inc"

LvlST:
#include "LvlST.inc"

.end
